Attribute VB_Name = "ReducePeso_CeldasCombinadas160"
Option Explicit
'http://office.microsoft.com/es-es/help/quitar-espacios-y-caracteres-no-imprimibles-del-texto-HP010062743.aspx
'http://jldexcelsp.blogspot.com/2012/10/el-extrano-caso-del-espacio-inamovible.html
'---------------------------------------------------------------------------------------
' Procedure : Limpiar_rangos
' Author    : Mauricio Robayo
' Date      : 01/04/2010
' Purpose   : Reduce el peso de un archivo de Excel limpiando el rango que fue usado y "aparentemente" ahora vacio.
' Comments  : http://www.excelpatas.com/2010/05/reducir-el-tamano-de-un-archivo-de.html
'---------------------------------------------------------------------------------------
'LAS 4 SIGUIENTES MACROS TRABAJAN UNIDAS EN UNA SOLA
'Reduce el peso del libro, limpiando TODO de las celdas que fueron usadas anteriormente y que ahora se encuentran vacias
Sub Limpiar_rangos() 'Crear un boton en la hoja para esta macro o F5 y Ejecutar
    Dim hj As Excel.Worksheet
    Dim copia$, ffin&, cfin&, TI&, TF&
'    Dim vffin As Integer: Dim vcfin As Integer ----- Agregado por Gerson Pineda
    copia = crear_copia(ActiveWorkbook)
    MsgBox "Se ha creado una copia: " & vbLf & copia, vbInformation
        limpiar_todo
    With ActiveWorkbook
        TI = VBA.FileLen(.FullName)
        For Each hj In .Worksheets
            ffin = 1
            cfin = 1
            With hj
' Anulada por Gerson Pineda
                On Error Resume Next
                ffin = .UsedRange.Find(what:="*", LookIn:=xlFormulas, _
                        SearchOrder:=xlByRows, SearchDirection:=xlPrevious).Row
                cfin = .UsedRange.Find(what:="*", LookIn:=xlFormulas, _
                        SearchOrder:=xlByColumns, SearchDirection:=xlPrevious).Column
                On Error GoTo 0
'Fin de anulacion
'Agregada por Gerson Pineda
'                With .UsedRange
'                    ffin = .Rows.Count
'                    cfin = .Columns.Count
'                End With
'Fin del Agregado por Gerson Pineda
                If .ProtectContents Then
                    If MsgBox("La hoja " & .Name & " se encuentra protegida." & vbLf & vbLf & _
                              "No se podrn limpiar los rangos de esta hoja a menos que se desproteja." _
                              & vbLf & vbLf & "Desea desprotegerla antes de continuar?", vbYesNo, _
                              "Hoja protegida!") = vbYes Then
                        If Desproteger(hj) Then
'                            .Cells(ffin, cfin) = "'" 'Agregado por Gerson Pineda
                        
                            Limpiar hj, ffin, cfin
                        Else
                            MsgBox "No se ha desprotegido la hoja.", vbCritical, "Clave incorrecta!"
                        End If
                    End If
                Else
'                    .Cells(ffin, cfin) = "'" 'Agregado por Gerson Pineda
                
                    Limpiar hj, ffin, cfin
                End If
            End With
        Next hj
        .Save
        TF = VBA.FileLen(.FullName)
    End With
    MsgBox "Tamao original: " & VBA.Format(TI, "#,##0") & " bytes." & vbLf & vbLf & _
           "Tamao final: " & VBA.Format(TF, "#,##0") & " bytes." & vbLf & vbLf & _
           "El archivo se redujo en: " & VBA.Format(TI - TF, "#,##0") & " bytes" & _
           " (" & VBA.FormatPercent(Abs(TI / TF - 1), 2) & ")."
End Sub
Private Function Desproteger(ByVal hj As Excel.Worksheet) As Boolean
    On Error Resume Next
    hj.Unprotect
    Desproteger = Not VBA.CBool(Err.Number)
    On Error GoTo 0
End Function
Private Sub Limpiar(ByVal hj As Excel.Worksheet, ByVal ffin As Long, ByVal cfin As Long)
    With hj
        With .Range(.Cells(ffin + 1, 1), .Cells(.Rows.Count, 1)).EntireRow
            If .MergeCells = False Then .Clear
        End With
                With .Range(.Cells(1, cfin + 1), .Cells(1, .Columns.Count)).EntireColumn
            If .MergeCells = False Then .Clear
        End With
    End With
End Sub
Private Function crear_copia(ByVal Libro As Excel.Workbook) As String
        With Libro
            .Save
            crear_copia = .Path & Application.PathSeparator & VBA.Format(VBA.Now, "d-m-yy h-mm ") & .Name
            .SaveCopyAs crear_copia
        End With
End Function

'Las 2 macro siguientes quitan los espacios generados por el carcter 160 (invisibles de Excel)
'esta en todo el libro
Sub limpiar_todo()
    Cells.Replace what:=Chr(160), Replacement:="", LookAt:=xlPart, _
        SearchOrder:=xlByRows, MatchCase:=False, SearchFormat:=False, _
        ReplaceFormat:=False
    MsgBox "Se ha limpio el espacio generado por caracter 160 ", vbInformation, "Informacin"
End Sub

'Esta macro quita todos los espacios generados por el carcter 160 (invisibles de Excel)
'esta en el rango seleccionado.
Sub limpiar_Seleccion()
    Selection.Replace what:=Chr(160), Replacement:="", LookAt:=xlPart, _
        SearchOrder:=xlByRows, MatchCase:=False, SearchFormat:=False, _
        ReplaceFormat:=False
End Sub

Sub Verifica_CeldasCombinadas() 'Este nada tiene que ver con todo lo anterior. Crear un boton en la _
hoja para esta macro o F5 y Ejecutar. Muestra las celdas combinadas vacias que anteriormente fueron _
usadas para poder quitarle el formato de combinar celdas y poder usar el boton de limpiar
  Dim AnyMerged As Variant

  AnyMerged = ActiveSheet.UsedRange.MergeCells

  If AnyMerged = False Then
      MsgBox "No hay celdas combinadas" & vbCrLf & vbCrLf & "puede usar el botn Limpiar rangos", vbInformation, "Informacin"
  ElseIf AnyMerged = True Then
      MsgBox "Todo combinado, & vbCrLf & vbCrLf &  antes individualise las celdas" & vbCrLf & "para poder usar el botn Limpiar rangos", vbInformation, "Informacin"
  ElseIf IsNull(AnyMerged) Then
      MsgBox "Hay celdas combinadas," & vbCrLf & vbCrLf & "tiene que individualisarlas para poder" & vbCrLf & "limpiar los rangos usados vacios", vbInformation, "Informacin"
  Else
      MsgBox "nunca llegu aqui - slo d 3 opciones"
  End If

End Sub

